/*
   (c)2014-2018 Forward Computing and Control Pty. Ltd.
   NSW Australia, www.forward.com.au
   This code is not warranted to be fit for any purpose. You may only use it at your own risk.
   This code may be freely used for both private and commercial use
   Provide this copyright is maintained.
*/

#include "Button.h"

Button::Button(char _cmd, pfodDwgs *_dwgsPtr) : pfodControl(_dwgsPtr) {
  buttonCmd = _cmd;
  z_idx = pfodDwgs::reserveIdx(1); // z_idx to fill button over text
}

char Button::getCmd() {
  return buttonCmd;
}

void Button::draw() {
  // circle in a rectangle with a label below
  dwgsPtr->rectangle().color(dwgsPtr->BLUE).rounded().size(28, 10).offset(-14, -5).send();
  if (label != NULL) { // only send label if one set
    dwgsPtr->label().fontSize(+4).text(label).bold().color(dwgsPtr->BLACK).offset(0, 0).send();
  }
  dwgsPtr->touchZone().cmd(buttonCmd).size(28, 10).offset(-14, -5).send();
  dwgsPtr->touchAction().cmd(buttonCmd).action( //
    dwgsPtr->rectangle().idx(z_idx).filled().color(dwgsPtr->BLACK).rounded().size(28, 10).offset(-14, -5)
    // what to show when zone touched, note no .send() for this
  ).send();
  update(); // update with current state
}

void Button::update() {
  // nothing here just remove the touchAction above
}
