/*
   (c)2014-2019 Forward Computing and Control Pty. Ltd.
   NSW Australia, www.forward.com.au
   This code is not warranted to be fit for any purpose. You may only use it at your own risk.
   This code may be freely used for both private and commercial use
   Provide this copyright is maintained.
*/

#include "RHGauge.h"


RHGauge::RHGauge(pfodDwgs *_dwgsPtr) : pfodControl(_dwgsPtr) {
  z_idx = pfodDwgs::reserveIdx(3);
}


void RHGauge::draw() {

  dwgsPtr->arc().filled().color(dwgsPtr->SILVER).radius(5).start(90 + (RANGE / 2.0f)).angle(-RANGE).send();
  dwgsPtr->arc().filled().color(dwgsPtr->WHITE).radius(4).idx(z_idx + 1).start(90 + (RANGE / 2.0f)).angle(-RANGE).send();

  dwgsPtr->arc().filled().color(dwgsPtr->BLACK).radius(5.5).start(90 + (RANGE / 2.0f)).angle(0).send();
  dwgsPtr->arc().filled().color(dwgsPtr->BLACK).radius(5.5).start(90).angle(0).send();
  dwgsPtr->arc().filled().color(dwgsPtr->BLACK).radius(5.5).start(90 - (RANGE / 2.0f)).angle(0).send();

  dwgsPtr->label().offset(-5.5, 2).fontSize(-6).text(("0%")).send();
  dwgsPtr->label().offset(0, -6.5).fontSize(-6).text(("50%")).send();
  dwgsPtr->label().offset(6.5, 2).fontSize(-6).text(("100%")).send();

  update(); // update with current state
}

void RHGauge::update() {
  dwgsPtr->arc().filled().color(dwgsPtr->BLUE).radius(5).idx(z_idx).start(90 + (RANGE / 2.0f)).angle(-value).send();
  dwgsPtr->label().color(dwgsPtr->BLUE).idx(z_idx + 2).fontSize(0).offset(0, 2).bold().text(label).intValue(value)
  .maxValue(200).displayMax(100).decimals(0).units(("%")).send();
}
